/*
 * beeppcm.c
 * original code: SASANO Takayoshi
 *
 * --- public domain, no warranty.
 */

#include <basic.h>
#include <driver/pcat/sys.h>

typedef	long long	U64;

#define	rdtsc(x)	Asm("rdtsc" : "=a"((x)[0]), "=d"((x)[1]))
	
/* 夬Ԥ */
Inline	void	wait4timer_carry(void)
{
	UW	t[2];

	/* ȴ: little-endianȤƤ */
	do {
		rdtsc(t);
	} while (t[1] & 0x80000000);

	return;
}

/* Ԥ */
Inline	void	wait4timer(U64 next)
{
	U64	curr;

	do {
		rdtsc((UW *)&curr);
	} while (curr < next);

	return;
}

/* ԡ */
LOCAL	void	set_speaker(Bool state)
{
	if (state) out_b(0x61, in_b(0x61) | 0x03);
	else out_b(0x61, in_b(0x61) & ~0x03);

	return;
}

/* ץ */
Inline	void	play_sample(W rate, UB data)
{
	W	f;

	/* ٷ׻Τ */
	f = (2 * 1193180 * data) / (rate * 255);

	out_b(0x43, 0xb6);
	out_b(0x42, f & 0xff);
	out_b(0x42, (f >> 8) & 0xff);

	return;
}	

/* 8bit, unsigned PCMǡ */
EXPORT	void	pcm_playu8(U64 cpuclk, W rate, UB *data, W len)
{
	U64	curr, next, step;
	UW	imask;
	W	i;

	/* Ԥַ׻ */
	step = cpuclk / rate;
	if (!step) goto fin0;    /* ̵¥롼ɻ */

	/* ߶ػ */
	DI(imask);

	/* ԡon */
	set_speaker(True);

	/* ߻μ */
	rdtsc((UW *)&curr);

	/* ꤷץ */
	for (i = 0; i < len; i++) {
		next = curr + step;
		play_sample(rate, *data++);
		if (next < curr) wait4timer_carry();
		wait4timer(next);
		curr = next;
	}

	/* ԡoff */
	set_speaker(False);

	/* ߵ */
	EI(imask);
 fin0:
	return;
}
